import java.io.IOException;

import jcuda.driver.CUcontext;
import jcuda.driver.CUdevice;
import jcuda.driver.CUdeviceptr;
import jcuda.driver.JCudaDriver;

public class JCudaDriverInit 
{
    public static void main(String args[]) throws IOException
    {
        // Initialize the driver and create a context for the first device.
    	JCudaDriver.setExceptionsEnabled(true);
    	System.out.println("Initializing");
        JCudaDriver.cuInit(0);
        CUcontext pctx = new CUcontext();
        CUdevice dev = new CUdevice();
        JCudaDriver.cuDeviceGet(dev, 0);
        JCudaDriver.cuCtxCreate(pctx, 0, dev);
        
        // Allocate some memory
    	System.out.println("Allocating");
        CUdeviceptr pointer = new CUdeviceptr();
        JCudaDriver.cuMemAlloc(pointer, 100);
        
    	System.out.println("Cleaning up");
    	JCudaDriver.cuMemFree(pointer);
        
    	System.out.println("Done");
    }

}
